Subject: Re: [tcpm] tcp window size

From: "Scheffenegger, Richard" <[email-masked]>
Date: Mon, 22 Jul 2019 16:23:58 -0400

Marc,

remember that in effect, the smaller between the sender's send buffer,
and the receiver's announced receive window can be used at a maximum,
since the sender has to hold on to any data until it receives positive
confirmation of delivery - in case the data has to be retransmitted
after a packet drop...

Regards,
    Richard

Am 20.05.2019 um 12:53 schrieb Yuchung Cheng:
> On Mon, May 20, 2019 at 9:23 AM Marc <[email-masked]> wrote:
>>
>> Hello experts,
>>
>> I've been trying to find definitive information about tcp window size
>> negotiation, and if it exists at all.
>>
>> Take a browser that downloads a file (receiver) and a webserver (sender). If
>> - both sender and receiver support window scaling
>> - the receiver advertises a TCP winsize of 256KB
>> - the sender advertises a window size of 32KB
>> - the sender has enough space in its TCP send buffer
>> (/proc/sys/net/ipv4/tcp_wmem on linux)
>>
>> How much 'outstanding unacked data' is the sender allowed to have,
>> 32KB or 256KB ?
>>
>> I can't see any logic for it being limited to the window size of the
>> sender (32KB), I think it depends on both the receiver winsize and the
>> sender TCP Send Buffer Size, but I need to be sure.
>>
>> Reading https://tools.ietf.org/html/rfc793 also suggests there is no
>> such thing like window size 'negotiation' and each end of a TCP
>> connection just advertises its own to indicate how much data it can
>> receive, independently.
>>
>> Is that correct ?
> That's correct. It's FYI not negotiated.
>>
>> Thanks!
>>
>> _______________________________________________
>> tcpm mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/tcpm
>
> _______________________________________________
> tcpm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/tcpm
>